#!/usr/bin/env python
# weili@jimmy.harvard.edu

import numarray, sys,re

class Hit:
    pass

class Bpmaptxt:
    '''store data in bpmapfile, self.seq['chr21'] = [hit, hit, ..., hit,....]
    hit.PMX, hit.PMY, hit.Position, hit.PMProbe
    hit.MMX = hit.PMX, hit.MMY = hit.PMY +1
    '''

    def __init__(self, filename, dir):
        '''read the bpmap file first to get the seq(chromosome) information, but del the data to save memory
        you have to use the Read() to get the real data
        '''
        try:
            bpfilehandle = open(dir + "/" + filename)
        except:
            print >> sys.stderr, 'Cannot open ', dir + "/" + filename
            sys.exit()
        head = bpfilehandle.readline()
        if not self._test_head(head):
            print >> sys.stderr, 'File format error, please check your bpmap file ', filename
            sys.exit()

        #read the bpmap file to get the chromosome, but not real data
        print >> sys.stderr, "Reading ",filename
        self.seq = {}
        for x in bpfilehandle:
            x = x.split()
            self.seq[ x[2] ] =[]
        self.bpfilehandle = bpfilehandle
        self.filename = filename

    def _test_head(self, head):
        head = head.split()
        for x ,y in zip( ['X','Y','Seq','Pos','Probe'], head):
            if x != y:
                return False
        return True

    def Read(self):
        print >> sys.stderr, "Reading ", self.filename
        self.bpfilehandle.seek(0)
        self.bpfilehandle.readline()
        for x in self.bpfilehandle:
            x = x.split()
            hit = Hit()
            hit.PMX = int(x[0])
            hit.PMY = int(x[1])
            hit.Position = int(x[3])
            hit.PMProbe = x[4]
            self.seq[ x[2] ].append(hit)

    def Close(self):
        for chr in self.seq.keys():
            self.seq[chr]=[]

    def GetProbe(self, chr):
        '''get numarray data structure, [chipid,  PMX, PMY, Position] from input chr (seq)'''
        nhit = len(self.seq[chr])
        data = numarray.zeros( (nhit, 4))
        for ihit in range( nhit ):
            hit = self.seq[chr][ihit]
            data[ihit] = [-1,  hit.PMX, hit.PMY,  hit.Position]
        return data

